/*
Copyright (C) 2002 Aaron J. Drabeck 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#define ATAC_IMMUNITY_LEVEL 	(1<<0) // ADMIN_IMMUNITY Flag (amxconst.inc for more info)

//PlayerFlags
#define SETTODIE 	(1<<0) // 1
#define CHICKEN 	(1<<1) // 2
#define JAILED 		(1<<2) // 4
#define GLOWING 	(1<<3) // 8
#define BLIND 		(1<<4) // 16 
#define TIMEBOMB	(1<<5) // 32
#define FIRE		(1<<6) // 64

#include <amxmod>
#include <amxmisc>

//PLAYER FLAGS
new PlayerFlags[33]
new TK[33][33] /* format: killer/victim (For use with Victim Menu) */
new TKHistory[33][33] /* format: killer/victim (For use with /whotkedme)*/
new TA[33]
new KickMe[33] 
new bool:taAllowed = true 
new ChickenCount /* Chicken Variables */
new StoredName[33][32]
new JailedCount /* Jail Variables */
new PreJailOrigin[33][3]
new map_cors_pre
new map_cors_origin[3]
new countdown[33]  /* Time Variable */
new gmsgHealth /* Game Messages */
new gmsgBattery
new gmsgShake
new gmsgFade
new gmsgDeathMsg
new gmsgStatusText 
new gmsgDamage
new atac_tacontrol = 1
new savedtks[300][35] /* Saved TeamKills */
new savedtkcount 
new authids[33][32]
new atac_status_off[33]
new light /* Sprites */
new white
new smoke
new fire
new m_fireball
new mflash 
new m_blueflare2

/***********************************  TA FUNCTION *********************************/
public event_Damage(vIndex)
{ 
	
	if ( !atac_tacontrol ) 
		return PLUGIN_CONTINUE

	new aIndex = get_user_attacker(vIndex)
	
	if (!aIndex)
		return PLUGIN_CONTINUE
	
	new aTeam = get_user_team(aIndex)
	new vTeam = get_user_team(vIndex)

	if (aTeam != vTeam || vIndex == aIndex)	
		return PLUGIN_CONTINUE

	new damage = read_data(2)
	
	//Set TA hud msg format
	if(aTeam == 1) 
		set_hudmessage(140, 0, 0, 0.75, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 9)
	else if(aTeam == 2) 
		set_hudmessage(0, 100, 200, 0.75, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 9)
		
	//Immunity Check
	if( (get_user_flags(aIndex)&ATAC_IMMUNITY_LEVEL) && get_cvar_float("atac_admins_immune") )
	{
		show_hudmessage(aIndex,"[ATAC] TEAMATTACK WARNING IMMUNE^n(Damage Inflicted:%i)",damage)
		return PLUGIN_CONTINUE
	}

	if( !taAllowed ) {
	
		if ( get_cvar_float("atac_tanotallowedfor") )
		{
			new aName[32]
			get_user_name(aIndex,aName,31)
			
			//Set TK hud msg format
			if(aTeam == 1) 
				set_hudmessage(140, 0, 0, 0.05, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 10)
			else if(aTeam == 2) 
				set_hudmessage(0, 100, 200, 0.05, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 10)
			show_hudmessage(0,"[ATAC] %s is slayed for attacking a teammate within %i secs of new round",
				aName,get_cvar_num("atac_tanotallowedfor"))
				
			slay(aIndex,1)
		
		}
	}
	else 
	{		 
		//increase attackers TA by index
		TA[aIndex]++	
		update_stat_text(aIndex)	
		
		new atac_ta_equal_v = get_cvar_num("atac_ta_equal_v")
		
		show_hudmessage(aIndex,"[ATAC] TEAMATTACK WARNING %i/%i^n(Damage Inflicted:%i)", 
			TA[aIndex], atac_ta_equal_v ,damage)				
		
		//Slap Bit 
		if (get_cvar_num("atac_ta_slap")) 
			user_slap(aIndex,0)
		
		//Mirror Damage bit 
		if (get_cvar_num("atac_ta_mirrordmg"))   {
			new aHeath = get_user_health(aIndex)
			if(damage >= aHeath)
				set_user_health(aIndex,1)
			else
				set_user_health(aIndex,aHeath - damage)
		}
		
		//Restore Bit 
		if (get_cvar_float("atac_ta_restore") && is_user_alive(vIndex) ) 
			set_user_health(vIndex, get_user_health(vIndex) + damage)	
		
		//Check for last warning 
		if (TA[aIndex] == atac_ta_equal_v )   { 
			//if TA is equal to get_cvar_num("atac_ta_equal_v") then treat it as tk (add 1 TK point)
			KickMe[aIndex]++
			check_v(aIndex)
			//reset TA count
			TA[aIndex] = 0					
			if ( get_cvar_float("atac_slayonmaxtas") ) 
				slay(aIndex,1)
		}		
	}	
	return PLUGIN_CONTINUE
}

/**********************************  TK FUNCTIONS *********************************/

public event_Death(id)
{		
	if ( get_cvar_float("atac_tkcontrol") )   {
		new kIndex = read_data(1)
		new vIndex = read_data(2)
		if(PlayerFlags[vIndex] & TIMEBOMB)   {
			new kName[32]
			get_user_name(kIndex,kName,31)
			client_print(id,3,"* [ATAC] %s has neutralized the timebomber!", kName)
			PlayerFlags[vIndex] -= TIMEBOMB
		}
		if(PlayerFlags[vIndex] & FIRE)   {
			emit_sound(kIndex,CHAN_AUTO, "scientist/scream21.wav", 0.6, ATTN_NORM, 0, PITCH_HIGH)
			PlayerFlags[vIndex] -= FIRE
		}
		if ( kIndex && kIndex != vIndex )   {
			if ( get_user_team(kIndex) == get_user_team(vIndex) )   { /* check indexes of teams*/			
				if( (get_user_flags(kIndex)&ATAC_IMMUNITY_LEVEL) && get_cvar_num("atac_admins_immune") )   {
					//* [ATAC] Sorry, You can't punish admins
					client_print(vIndex,3,"* [ATAC] Sorry, You can't punish admins")
				}
				else {									
					//Store who killed who for history.
					TKHistory[kIndex][vIndex]++
					if( get_cvar_num("atac_menu") )  {
						TK[kIndex][vIndex]++ 
						//Check to see if someone needs the menu sent to them.						
						if (KickMe[kIndex] >= get_cvar_num("atac_tk_before_ban") - 1)
							draw_menu_final(kIndex,vIndex)							
						else
							draw_menu_page1(kIndex,vIndex)
					}
					else   {
						KickMe[kIndex]++ 
						check_v(kIndex)
					}						
					update_stat_text(kIndex)						
				}
			}
		}
	}
	return PLUGIN_CONTINUE
}

find_killer(vIndex)
{
	//Get Killer (if more than one killer, handle last one in array order first)
	new kIndex = 0, maxplayers = get_maxplayers()
	for(new k = 1; k <= maxplayers; ++k) 
		if(TK[k][vIndex] > 0)
			kIndex = k
	return kIndex
}

/********************************  CHECK TK FUNCTION *******************************/
check_v(kIndex) {
	
	if( !is_user_connected(kIndex) )
		return PLUGIN_CONTINUE
			
	//Check to see if player has any TK's left then ban or warn
	new kName[32]
	new kAuthid[32]
	new kIP[32]
	new Date[64]
	new BanInfo[256]
	
	get_user_name(kIndex,kName,31)
	get_user_authid(kIndex,kAuthid,31)
	get_user_ip(kIndex,kIP,31,1)
	get_time("%m/%d/%y %H:%M:%S",Date,63)
	
	//Set TK hud msg format 
	if(get_user_team(kIndex) == 1) 
		set_hudmessage(140, 0, 0, 0.05, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 10)
	else if(get_user_team(kIndex) == 2) 
		set_hudmessage(0, 100, 200, 0.05, 0.50, 2, 0.1, 4.0, 0.02, 0.02, 10)
				
	new atac_tk_before_ban = get_cvar_num("atac_tk_before_ban")
	new atac_banvia = get_cvar_num("atac_banvia")
	new atac_bantime = get_cvar_num("atac_bantime")
	
	update_stat_text(kIndex)			
	//Check if user needs to be banned.
	if (KickMe[kIndex] >= atac_tk_before_ban ) 
	{
		if( atac_banvia == 1 || atac_banvia == 2) 
		{
			if( atac_bantime )
			{
				client_print(kIndex,1,"You have been banned for %i mins for Team Kill Violations", atac_bantime )	
				show_hudmessage(0,"[ATAC] TEAM KILL VIOLATION %i/%i for %s.^nBanning for %i mins...",
					KickMe[kIndex], atac_tk_before_ban ,kName, atac_bantime )
				format(BanInfo ,255 ,"L %s - ^"%s<%s><%s>^" ^"Team Kill Violations: %i of %i banned for %i min^" ",
					Date,kName,kIP,kAuthid,KickMe[kIndex], atac_tk_before_ban , atac_bantime )
			}
			else
			{
				client_print(kIndex,1,"You have been banned permanently for Team Kill Violations")	
				show_hudmessage(0,"[ATAC] TEAM KILL VIOLATION %i/%i for %s.^nBanning permanently...",
					KickMe[kIndex], atac_tk_before_ban ,kName)
				format(BanInfo ,255 ,"L %s - ^"%s<%s><%s>^" ^"Team Kill Violations: %i of %i banned permanently^" ",
					Date,kName,kIP,kAuthid,KickMe[kIndex], atac_tk_before_ban )	
			}
		} 
		else if( atac_banvia == 3)
		{
			client_print(kIndex,1,"You have been kicked for Team Kill Violations")	
			show_hudmessage(0,"[ATAC] TEAM KILL VIOLATION %i/%i for %s.^nKicking...",
				KickMe[kIndex], atac_tk_before_ban ,kName)	
			format(BanInfo ,255 ,"L %s - ^"%s<%s><%s>^" ^"Team Kill Violations: %i of %i kicked from server^"",
				Date,kName,kIP,kAuthid,KickMe[kIndex], atac_tk_before_ban )
		}	
		write_file("addons\amx\plugins\atac\atacban.log",BanInfo,-1)
		//Ban Player
		if( atac_banvia == 1)
		{
			server_cmd("banid %i %s kick", atac_bantime ,kAuthid)
		}
		else if( atac_banvia == 2) 
		{
			//IP BIT
			server_cmd("addip %i %s", atac_bantime ,kIP)		
			server_cmd("kick # %s",kAuthid)
		}	
		else if( atac_banvia == 3)
		{
			server_cmd("kick #%d",get_user_userid(kIndex))
		}
	} 
	else
	{
		if( atac_banvia == 1 || atac_banvia == 2 )
		{
			if (atac_bantime)
			{
				show_hudmessage(0,"[ATAC] TEAM KILL VIOLATION %i/%i for %s.^nOn %i you will be banned for %i mins",
					KickMe[kIndex],atac_tk_before_ban,kName,atac_tk_before_ban,atac_bantime)
			}
			else
			{
				show_hudmessage(0,"[ATAC] TEAM KILL VIOLATION %i/%i for %s.^nOn %i you will be banned permanently",
					KickMe[kIndex],atac_tk_before_ban,kName,atac_tk_before_ban)
			}
		}
		else if( atac_banvia == 3)
		{
			show_hudmessage(0,"[ATAC] TEAM KILL VIOLATION %i/%i for %s.^nOn %i you will be kicked",
				KickMe[kIndex], atac_tk_before_ban ,kName, atac_tk_before_ban )	
		}
	}
	return PLUGIN_CONTINUE
}

/*******************************  START ROUND FUNCTIONS ****************************/
public preround_start()
{
	new maxplayers = get_maxplayers()
		
	for(new i = 1 ;i <= maxplayers; ++i)
	{
		if (PlayerFlags[i] & SETTODIE)
		{
			slay(i,1)
			PlayerFlags[i] -= SETTODIE
		} 
		if(PlayerFlags[i] & CHICKEN) 
		{
			new kName[32]
			get_user_name(i,kName,31)
			server_cmd("c_unchicken # %i", i)
			if ( get_cvar_num("atac_handlenames") )
				client_cmd(i,"name ^"%s^"",StoredName[i])
			client_print(0,3,"* [ATAC] %s has been turned back into a human",StoredName[i]) 
			PlayerFlags[i] -= CHICKEN
			ChickenCount--
		}
		if(PlayerFlags[i] & JAILED) 
		{
			new kName[32]
			get_user_name(i,kName,31)
			if ( get_cvar_num("atac_handlenames") )
				client_cmd(i,"name ^"%s^"",StoredName[i])
			client_print(0,3,"* [ATAC] %s has served his jail sentence",StoredName[i])
			PlayerFlags[i] -= JAILED
			JailedCount--
		}
		if (PlayerFlags[i] & GLOWING)
		{
			set_user_rendering(i,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,255)
			PlayerFlags[i] -= GLOWING
		}
		if(PlayerFlags[i] & BLIND)   {
			PlayerFlags[i] -= BLIND
		}
	}
	return PLUGIN_CONTINUE
}

public event_RoundTime()
{
	new Float:roundtime = get_cvar_float("mp_roundtime") * 60.0
	new rtime = read_data(1) 
	
	//Round Start at start of freeze time
	if ( get_cvar_num("mp_freezetime") == rtime )   {
		set_task( 0.3 , "preround_start")		
		
		new maxplayers = get_maxplayers()
		for(new i = 1 ;i <= maxplayers; ++i)
			TA[i] = 0
	}
	
	//Round Start after freezetime
	else if ( roundtime == rtime )   {
		new Float:tanot = get_cvar_float("atac_tanotallowedfor")
		if( tanot )  {
			taAllowed = false /*Set timer for TA within x seconds get slayed. */
			set_task( tanot , "ta_NA_timer")	
		}
		
		atac_tacontrol = get_cvar_num("atac_tacontrol")
	}
	return PLUGIN_CONTINUE
}

public ta_NA_timer() 
{
	taAllowed = true
	return PLUGIN_CONTINUE
}

/********************************  MENU FUNCTIONS *********************************/

draw_menu_page1(kIndex,vIndex)   {
	
	new menuoption[10][64],	keys = (1<<0)|(1<<9)
	
	for(new z = 0; z < 10; ++z) // clear string
		menuoption[z][0] = 0
			
	if ( get_cvar_float("atac_option_slap") )   {
		keys |= (1<<1)	
		format(menuoption[0], 63, "2. Slap him \y%i\w times", get_cvar_num("atac_tk_slaps"))
	}
	if ( get_cvar_float("atac_option_slapto1") )   {
		keys |= (1<<2)
		copy(menuoption[1],63,"3. Slap him to \y1\w heath")
	}
	if ( get_cvar_float("atac_option_slay_nr") )   {
		keys |= (1<<3)
		copy(menuoption[2],63,"4. Slay him Nextround")
	}
	if ( get_cvar_float("atac_option_jail") && map_cors_pre)   {
		keys |= (1<<4)
		format(menuoption[3], 63, "5. Put him in Jail for \y%i\w seconds", get_cvar_num("atac_jailtime"))
	}
	if ( get_cvar_float("atac_option_chicken") && cvar_exists("chicken_version") )   {
		keys |= (1<<5)
		copy(menuoption[4],63,"6. Turn him into a Chicken")   
	}
	if ( get_cvar_float("atac_option_bury") )   {
		keys |= (1<<6)
		copy(menuoption[5],63,"7. Bury Him")
	}
	if ( get_cvar_float("atac_option_glow") )   {
		keys |= (1<<7)
		copy(menuoption[6],63,"8. Make him Glow Pink")
	}
	
	new kName[32], menubody[512]
	get_user_name(kIndex,kName,31)
	format(menubody,511,"\y[ATAC] Menu 1/2\w^n^nChoose Punishment for^n\r%s^n^n\w1. Forgive Him^n%s^n%s^n%s^n%s^n%s^n%s^n%s^n^n0. More",
		kName,menuoption[0],menuoption[1],menuoption[2],menuoption[3],menuoption[4],menuoption[5],menuoption[6])
	show_menu(vIndex,keys,menubody)
	
	return PLUGIN_HANDLED
}

draw_menu_page2(kIndex,vIndex)   {
	
	new menuoption[10][64], keys = (1<<9)
	
	for(new z = 0; z < 10; ++z) // clear string
		menuoption[z][0] = 0
	
	if ( get_cvar_float("atac_option_bomb") )   {
		keys |= (1<<0)
		copy(menuoption[0],63,"1. Make him a ticking Timebomb")
	}
	if ( get_cvar_num("atac_option_blind") )   {
		keys |= (1<<1)
		copy(menuoption[1],63,"2. Make him Blind")
	}
	if ( get_cvar_float("atac_option_rocket") )   {
		keys |= (1<<2)
		copy(menuoption[2],63,"3. Make him a Rocket")
	}	
	if ( get_cvar_float("atac_option_drop") )   {
		keys |= (1<<3)	
		copy(menuoption[3],63,"4. Drop him Repeatedly")
	}
	if ( get_cvar_float("atac_option_fire") )   {
		keys |= (1<<4)	
		copy(menuoption[4],63,"5. Set him on fire")
	}
	
	new kName[32], menubody[512]
	get_user_name(kIndex,kName,31)
	format(menubody,511,"\y[ATAC] Menu 2/2\w^n^nChoose Punishment for^n\r%s^n^n\w%s^n%s^n%s^n%s^n%s^n^n^n^n^n0. Back",
		kName,menuoption[0],menuoption[1],menuoption[2],menuoption[3],menuoption[4])
	show_menu(vIndex,keys,menubody)
	return PLUGIN_HANDLED
}

draw_menu_final(kIndex,vIndex)   {
	
	new menu_option[64]
	new atac_bantime = get_cvar_num("atac_bantime")
	new atac_banvia = get_cvar_num("atac_banvia")	
	
	if ( atac_banvia == 1 || atac_banvia == 2 )   {
		if (atac_bantime)					
			format(menu_option, 63, "2. Ban him for \y%i\w minutes", atac_bantime )		
		else
			copy(menu_option,63,"2. Ban him permanently")		
	}
	else if ( atac_banvia == 3)
		copy(menu_option,63,"2. Kick Him")
	
	new kName[32], menubody[512]
	get_user_name(kIndex,kName,31)
	format(menubody,511,"\y[ATAC] Menu Final\w^n^nChoose Punishment for^n\r%s^n^n\w1. Forgive Him^n%s",kName,menu_option)
	show_menu(vIndex, ( (1<<0)|(1<<1) ) ,menubody) 
	
	return PLUGIN_HANDLED
}

menu_check(vIndex)
{
	new maxplayers = get_maxplayers()
	for(new k = 1; k <= maxplayers; ++k)   {
		if(TK[k][vIndex] > 0)   {
			draw_menu_page1(vIndex,k)
			return PLUGIN_CONTINUE
		}
	}	
	return PLUGIN_CONTINUE
}

public action_menu_page1(vIndex,key)   {
	
	new kIndex = find_killer(vIndex)
	new vName[32], kName[32]
	get_user_name(vIndex,vName,31)
	get_user_name(kIndex,kName,31)
	new skIndex[2]
	skIndex[0] = kIndex
	
	switch(key)  {
		case 0:   {    /* Option Forgive */
		
			client_print(0,3,"* [ATAC] %s has forgiven %s",vName,kName)
			return PLUGIN_HANDLED
		}
		case 1:   {    /* Option Slap */
		
			new atac_tk_slaps = get_cvar_num("atac_tk_slaps")
			client_print(0, 3, "* [ATAC] %s got slapped %i times for TKing %s", kName, atac_tk_slaps, vName)
			// Slap Bit
			new Float:atac_slap_freq = get_cvar_float("atac_slap_freq")
			if (atac_slap_freq < 0.1 )
				atac_slap_freq = 0.1
			set_task(atac_slap_freq, "slap", 0, skIndex, 3, "a", atac_tk_slaps-1)	
		}
		case 2:   {  /* Option Slap to 1 */
		
			client_print(0,3,"* [ATAC] %s has slaped %s to 1 heath for TKing him",vName,kName)
			// Slap Bit 
			new user_heath = get_user_health(kIndex)
			user_slap(kIndex,user_heath - 1)			
		}
		case 3:   { /* Option Slay Next Round */
		
			client_print(0,3,"* [ATAC] %s will die next round for TKing %s",kName,vName)
			if ( !(PlayerFlags[kIndex] & SETTODIE) ) 
				PlayerFlags[kIndex] += SETTODIE			
		}
		case 4:   {  /* Option Jail */
		
			client_print(0,3,"* [ATAC] %s is in jail for %i seconds for TKing %s",kName,get_cvar_num("atac_jailtime"),vName)
			if ( is_user_alive(kIndex) )   {
				if ( !(PlayerFlags[kIndex] & JAILED) )   {
					JailedCount++
					StoredName[kIndex] = kName
					if ( get_cvar_num("atac_handlenames") )
						client_cmd(kIndex,"name ^"Inmate #00%i^"",JailedCount)
					PlayerFlags[kIndex] += JAILED					
				}
				//set_user_origin bit
				new iwpn, iwpns[32], nwpn[32]
				get_user_weapons(kIndex,iwpns,iwpn)
				for(new a = 0; a < iwpn;++a)   {
					get_weaponname(iwpns[a],nwpn,31)
					engclient_cmd(kIndex,"drop",nwpn)
				}
				if ( map_cors_pre )   {
					get_user_origin(kIndex,PreJailOrigin[kIndex])
					PreJailOrigin[kIndex][2] += 5
					set_user_origin(kIndex,map_cors_origin)
					set_task(get_cvar_float("atac_jailtime"), "un_jail" , 0 , skIndex, 3)
					//client_print(0,1,"DEBUG: x:%i, y:%i, z:%i",map_cors_origin[0],map_cors_origin[1],map_cors_origin[2]) 
				}					
			}						
		}
		case 5:   {  /* Option Chicken */
					
			client_print(0,3,"* [ATAC] %s has been turned into a Chicken for TKing %s",kName,vName)
			if ( is_user_alive(kIndex) ) 
			{
				if ( !(PlayerFlags[kIndex] & CHICKEN) )   {
					//CHICKEN BIT
					ChickenCount++
					emit_sound(kIndex,CHAN_ITEM, "misc/chicken0.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
					server_cmd("c_chicken # %i", kIndex)
					StoredName[kIndex] = kName
					if ( get_cvar_num("atac_handlenames") )   							
						client_cmd(kIndex,"name ^"Chicken #00%i^"",ChickenCount)
					PlayerFlags[kIndex] += CHICKEN									
				}
			}							
		}
		case 6:   {   /* Option Bury */
		
			client_print(0,3,"* [ATAC] %s has buried %s for TKing him",vName,kName)
			if ( is_user_alive(kIndex) ) 
			{
				//Bury Bit 
				new iwpn, iwpns[32], nwpn[32]
				get_user_weapons(kIndex,iwpns,iwpn)
				for(new a = 0; a < iwpn;++a)
				{
					get_weaponname(iwpns[a],nwpn,31)
					engclient_cmd(kIndex,"drop",nwpn)
				}
				new origin[3]
				get_user_origin(kIndex, origin)
				origin[2] -= 30
				set_user_origin(kIndex, origin)
			}
			
		}
		case 7:   {   /* Option Glow */
		
			client_print(0,3,"* [ATAC] %s has made %s glow pink for TKing him",vName,kName)
			//Glow bit
			if ( !(PlayerFlags[kIndex] & GLOWING) )   
				PlayerFlags[kIndex] += GLOWING
			set_user_rendering(kIndex,kRenderFxGlowShell,255,0,255,kRenderTransAlpha,255)
			
		}	
		case 9:   {   /* Option More...*/
		
			 draw_menu_page2(kIndex,vIndex) 
			 return PLUGIN_HANDLED
		}			
	}		
	
	TK[kIndex][vIndex]--
	menu_check(vIndex)
	KickMe[kIndex]++
	check_v(kIndex)
	return PLUGIN_HANDLED
}

public action_menu_page2(vIndex,key)   {
	new kIndex = find_killer(vIndex)
	new vName[32], kName[32]
	get_user_name(vIndex,vName,31)
	get_user_name(kIndex,kName,31)
	new skIndex[2]
	skIndex[0] = kIndex
	
	switch(key)  {
		case 0:   {   /* Option Bomb */
			
			client_print(0,3,"* [ATAC] %s has made %s a ticking time bomb for TKing him",vName,kName)
			//TIME BOME BIT
			if ( !(PlayerFlags[kIndex] & TIMEBOMB) ) 
				PlayerFlags[kIndex] += TIMEBOMB
			countdown[kIndex] = 10
			set_task( 1.0, "time_bomb", 0, skIndex, 2 )
			
			
		}
		case 1:   {    /* Option Blind */
			
			client_print(0, 3, "* [ATAC] %s has made %s blind for TKing him", vName, kName)  				
			if ( is_user_alive(kIndex) && !(PlayerFlags[kIndex] & BLIND) )   {
				// Blind Bit  
				message_begin(MSG_ONE, gmsgFade, {0,0,0}, kIndex) // use the magic #1 for "one client"  
				write_short(1<<12) // fade lasts this long duration  
				write_short(1<<8) // fade lasts this long hold time  
				write_short(1<<0) // fade type IN 
				write_byte(0) // fade red  
				write_byte(0) // fade green  
				write_byte(0) // fade blue    
				write_byte(255) // fade alpha    
				message_end() 
				set_task(1.0, "dely_screen_fade" , 0 , skIndex, 2)				
				PlayerFlags[kIndex] += BLIND
			}							
		}
		case 2:   {  /* Option Rocket */
			
			client_print(0,3,"* [ATAC] %s has made %s into a Rocket for TKing him",vName,kName)
			// Rocket bit				
			if ( is_user_alive(kIndex) )   {
				emit_sound(kIndex,CHAN_WEAPON ,"weapons/rocketfire1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
				set_user_maxspeed(kIndex,0.01)								
				set_task(1.2, "rocket_sound" , 0 , skIndex, 2)
				set_task(0.2, "rocket_levatate" , 0 , skIndex, 2, "a", 20)
				set_task(4.0, "rocket_explode" , 0 , skIndex, 2)
				set_task(4.8, "stop_sound" , 0 )
				
			}		
		}	
		case 3:   {  /* Option Drop */
			
			client_print(0,3,"* [ATAC] %s has dropped %s Repeatedly for TKing him",vName,kName)
			// drop bit				
			if ( is_user_alive(kIndex) )   {										
				raise_player(skIndex)
			}
					
		}
		case 4:   {  /* Option Fire */
			
			client_print(0,3,"* [ATAC] %s has set %s on Fire for TKing him",vName,kName)
			// fire bit	
			if( !(PlayerFlags[kIndex] & FIRE) )   {
				PlayerFlags[kIndex] += FIRE
				ignite_effects(skIndex)
				ignite_player(skIndex)								
			}					
		}
		case 9:   {    /* Option Back... */
		
			draw_menu_page1(kIndex,vIndex)
			return PLUGIN_HANDLED
		}		
	}
	TK[kIndex][vIndex]--
	KickMe[kIndex]++
	check_v(kIndex)
	menu_check(vIndex)  //Check if Player needs menu agian
	return PLUGIN_HANDLED	
}

public action_menu_final(vIndex,key)   {
	
	new kIndex = find_killer(vIndex)
	new vName[32], kName[32]
	get_user_name(vIndex,vName,31)
	get_user_name(kIndex,kName,31)
	
	switch(key)  {
		case 0:   {    /* Option Forgive */
			client_print(0,3,"* [ATAC] %s has forgiven %s",vName,kName)
			TK[kIndex][vIndex]--
			menu_check(vIndex)
		}
		case 1:   {    /* Option BAN */			
			client_print(0,3,"* [ATAC] %s has banned %s on for TKing him",vName,kName)
			KickMe[kIndex]++
			check_v(kIndex) 
			menu_check(vIndex)			
		}
	}
	return PLUGIN_HANDLED
}

/**********************************  SLAP FUNCTION ********************************/

public slap(skIndex[])
{
	new kIndex = skIndex[0]
	if ( !is_user_alive(kIndex) )
		return PLUGIN_CONTINUE 
		
	if(get_user_health(kIndex) <= get_cvar_num("atac_slap_power"))
		user_slap(kIndex, 0)
		
	else
		user_slap(kIndex, get_cvar_num("atac_slap_power"))
	
	return PLUGIN_CONTINUE 
}

/**********************************  SLAY FUNCTION ********************************/

slay(id,type)
{
	if (is_user_alive(id)) 	{
		new origin[3]
		get_user_origin(id,origin)
		origin[2] = origin[2] - 26
		switch(type)   {
			case 1:   {
				lightning(origin)
				emit_sound(id,CHAN_ITEM, "ambience/thunder_clap.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
			case 2:   {
				explode(origin)
			}
			case 3:   {
				fireball(origin)
			}
		}			
		user_kill(id,1)
	}
	return PLUGIN_CONTINUE 
}

/********************************** JAIL FUNCTIONS *****************************/
public un_jail(skIndex[]) 
{
	new kIndex = skIndex[0]
	new kName[32]
	get_user_name(kIndex,kName,31)

	if(is_user_alive(kIndex) && PlayerFlags[kIndex] & JAILED )  {
		if ( get_cvar_num("atac_handlenames") )
			client_cmd(kIndex,"name ^"%s^"",StoredName[kIndex])
		client_print(0,3,"* [ATAC] %s has served his jail sentence",StoredName[kIndex]) 
		set_user_origin(kIndex,PreJailOrigin[kIndex])
		PlayerFlags[kIndex] -= JAILED
		JailedCount--
	}
	return PLUGIN_CONTINUE 
}


map_cors_present(maporigin[3])
{
	if(get_cvar_num("atac_option_jail") )   {
		if (file_exists("addons\amx\plugins\atac\atac.cor"))   {
			new readdata[64]
			new currentmap[32]
			get_mapname(currentmap,31)
			new map[32],x[16],y[16],z[16], len
			for(new i=0; i < 100 && read_file("addons\amx\plugins\atac\atac.cor",i,readdata,63,len); i++)    {
				parse(readdata,map,31,x,15,y,15,z,15)
				if(equal(map,currentmap))   {
					maporigin[0] = str_to_num(x)
					maporigin[1] = str_to_num(y)
					maporigin[2] = str_to_num(z)
					return 1
				}
			}	
		}				
	}
	return 0
}	

/***************************** BLIND FUNCTIONS ******************************/

public screen_fade(id) {
	new sId[2]
	sId[0] = id
	set_task(0.6, "dely_screen_fade" , 0 , sId, 2)
	return PLUGIN_CONTINUE
}

public dely_screen_fade(sid[]) {
	new id = sid[0]
	if(PlayerFlags[id] & BLIND)   {
		// Blind Bit  
		message_begin(MSG_ONE, gmsgFade, {0,0,0}, id) // use the magic #1 for "one client" 
		write_short(1<<0) // fade lasts this long duration 
		write_short(1<<0) // fade lasts this long hold time 
		write_short(1<<2) // fade type (in / out) 
		write_byte(0) // fade red 
		write_byte(0) // fade green 
		write_byte(0) // fade blue  
		write_byte(255) // fade alpha  
		message_end() 
	}
	return PLUGIN_CONTINUE
}
			
/********************************** ROCKET FUNCTIONS *****************************/
public rocket_sound(svictim[])   {
	
	new victim = svictim[0]
	set_user_gravity(victim,-0.50)
	client_cmd(victim,"+jump;wait;wait;-jump")
	emit_sound(victim,CHAN_WEAPON ,"weapons/rocket1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	return PLUGIN_CONTINUE
}

public rocket_levatate(svictim[])   {
	new victim = svictim[0]	
	new vorigin[3] 
	get_user_origin(victim,vorigin)	
			
	message_begin(MSG_ONE, gmsgDamage, {0,0,0}, victim) 
	write_byte(30) // dmg_save
	write_byte(30) // dmg_take 
	write_long(1<<16) // visibleDamageBits 
	write_coord(vorigin[0]) // damageOrigin.x 
	write_coord(vorigin[1]) // damageOrigin.y
	write_coord(vorigin[2]) // damageOrigin.z 
	message_end()
		
	draw_trail(vorigin)
	return PLUGIN_CONTINUE
	
}

public rocket_explode(svictim[])   {
	new victim = svictim[0]
		
	if ( is_user_alive(victim) )
		slay(victim,2)	/* Slay With Effects */	 
	
	set_user_maxspeed(victim,1.0)	
	set_user_gravity(victim,1.00)

	return PLUGIN_CONTINUE
}

public stop_sound()   {
	new players[32], inum = 0
	
	get_players(players,inum,"")
	for(new i = 0 ;i < inum; ++i)		
		client_cmd(players[i],"stopsound")
		
	return PLUGIN_CONTINUE	
}

/**********************************  DROP FUNCTIONS ********************************/
public raise_player(skIndex[]) {
	new kIndex = skIndex[0]
	
	if ( is_user_alive(kIndex) )   {
		set_user_gravity(kIndex,-2.0)
		client_cmd(kIndex,"+jump;wait;wait;-jump")
		set_task(1.3, "drop_player" , 0 , skIndex, 2)
	}
	else
		set_user_gravity(kIndex,1.0)
}

public drop_player(skIndex[]) {
	new kIndex = skIndex[0]
	
	if ( is_user_alive(kIndex) )   {
		set_user_gravity(kIndex,2.0)
		set_task(1.0, "raise_player" , 0 , skIndex, 2)
	}
	else
		set_user_gravity(kIndex,1.0)
}

/********************************** FIRE FUNCTION *****************************/
public ignite_effects(skIndex[])   {
	new kIndex = skIndex[0]
		
	if (is_user_alive(kIndex) && PlayerFlags[kIndex] &FIRE)    {
		new korigin[3] 
		get_user_origin(kIndex,korigin)
				
		draw_fire(korigin)
		set_task(0.2, "ignite_effects" , 0 , skIndex, 2)		
	}		
	return PLUGIN_CONTINUE
}

public ignite_player(skIndex[])   {
	new kIndex = skIndex[0]
		
	if (is_user_alive(kIndex) && PlayerFlags[kIndex] &FIRE)    {
		new korigin[3] 
		new players[32], inum = 0
		new pOrigin[3]		
		new kHeath = get_user_health(kIndex)
		get_user_origin(kIndex,korigin)
		
		//create some damage
		set_user_health(kIndex,kHeath - 10)
		message_begin(MSG_ONE, gmsgDamage, {0,0,0}, kIndex) 
		write_byte(30) // dmg_save
		write_byte(30) // dmg_take 
		write_long(1<<21) // visibleDamageBits 
		write_coord(korigin[0]) // damageOrigin.x 
		write_coord(korigin[1]) // damageOrigin.y
		write_coord(korigin[2]) // damageOrigin.z 
		message_end()
				
		//create some sound
		emit_sound(kIndex,CHAN_ITEM, "ambience/flameburst1.wav", 0.6, ATTN_NORM, 0, PITCH_NORM)
				
		//Ignite Others
		if ( get_cvar_num("atac_ignite_others") )    {		
			get_players(players,inum,"a")
			for(new i = 0 ;i < inum; ++i)   {									
				get_user_origin(players[i],pOrigin)				
				if( get_distance(korigin,pOrigin) < 100  )   {
					if( !(PlayerFlags[players[i]] & FIRE) )   {
						new spIndex[2] 
						spIndex[0] = players[i]
						new pName[32], kName[32]					
						get_user_name(players[i],pName,31)
						get_user_name(kIndex,kName,31)
						emit_sound(players[i],CHAN_WEAPON ,"scientist/scream07.wav", 1.0, ATTN_NORM, 0, PITCH_HIGH)
						client_print(0,3,"* [ATAC] OH! NO! %s has caught %s on fire!",kName,pName)
						PlayerFlags[players[i]] += FIRE
						ignite_player(players[i])
						ignite_effects(players[i])	
					}					
				}
			}			
			players[0] = 0
			pOrigin[0] = 0					
			korigin[0] = 0		
		}
		//Call Again in 2 seconds		
		set_task(2.0, "ignite_player" , 0 , skIndex, 2)		
	}	
		
	return PLUGIN_CONTINUE
}





/********************************** TIME BOMB FUNCTION *****************************/
public time_bomb(skIndex[])   {
		
	new speak[11][] = { "fire!", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "ten" } 
	new kIndex = skIndex[0]
	new red = random_num(0,255)
	new green = random_num(0,255)
	new blue = random_num(0,255)
	new alpha = random_num(100,255)
	new kName[32]
	new players[32], inum
	get_user_name(kIndex,kName,31)
	
	if (is_user_alive(kIndex))   {
		set_hudmessage(red, green, blue, -1.0, 0.25, 0, 1.2, 1.2, 0.5, 0.15, 5)	
		if (countdown[kIndex] > 0)   {
			//Glow Me 
			set_user_rendering(kIndex,kRenderFxGlowShell,red,green,blue,kRenderTransAlpha,alpha)
			//An0uce Me
			get_players(players,inum,"c")
			for(new i = 0 ;i < inum; ++i)
				client_cmd(players[i],"speak ^"fvox/%s^"",speak[countdown[kIndex]])
				
			show_hudmessage(0,"%s will explode in %i",kName,countdown[kIndex])
			
			message_begin(MSG_ONE,gmsgHealth,{0,0,0},kIndex) 
			write_byte( countdown[kIndex] )
			message_end() 			
			message_begin(MSG_ONE,gmsgBattery,{0,0,0},kIndex) 
			write_short( countdown[kIndex] )
			message_end()
			countdown[kIndex]--
			//Call Again
			set_task( 1.0, "time_bomb", 0, skIndex, 2)
		}
		else   {
			if ( PlayerFlags[kIndex] & TIMEBOMB ) 
				PlayerFlags[kIndex] -= TIMEBOMB
			set_user_rendering(kIndex,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,255)
			get_players(players,inum,"c")
			for(new i = 0 ;i < inum; ++i)   {
				client_cmd(players[i],"speak ^"fvox/%s^"",speak[ countdown[kIndex] ])	
				message_begin(MSG_ONE,gmsgShake,{0,0,0},players[i]) 
				write_short( 1<<14 )// shake amount
				write_short( 1<<14 )// shake lasts this long
				write_short( 1<<14 )// shake noise frequency
				message_end()
			}
			//FIRE!
			show_hudmessage(0,"FIRE!",kName)
			slay(kIndex,3)
			get_players(players,inum,"c")
			for(new i = 0 ;i < inum; ++i)
				client_cmd(players[i],"speak ^"hgrunt/%s^"",speak[ countdown[kIndex] ])
			
			//Fade to red for bomber  
			message_begin(MSG_ONE, gmsgFade, {0,0,0}, kIndex) // use the magic #1 for "one client" 
			write_short(1<<15) // fade lasts this long furation 
			write_short(1<<10) // fade lasts this long hold time 
			write_short(1<<1) // fade type OUT  
			write_byte(100) // fade red 
			write_byte(0) // fade green 
			write_byte(0) // fade blue  
			write_byte(255) // fade alpha  
			message_end()			
			
			if( get_cvar_float("atac_explosion_ap") )   {				
				get_players(players,inum,"a")
				for(new i = 0 ;i < inum; ++i)   {
					new pOrigin[3]					
					new kOrigin[3]
					get_user_origin(players[i],pOrigin)
					get_user_origin(kIndex,kOrigin)				
					if( get_cvar_num("atac_explosion_range") > get_distance(kOrigin,pOrigin) )   { 
						//Death Msg
						message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0)
						write_byte(kIndex)
						write_byte(players[i])
						write_byte(0)
						write_string("ATAC Timebomb")
						message_end()
						slay(players[i],0)
						
						//Fade to red for bomber  
						message_begin(MSG_ONE, gmsgFade, {0,0,0}, kIndex) // use the magic #1 for "one client" 
						write_short(1<<15) // fade lasts this long furation 
						write_short(1<<10) // fade lasts this long hold time 
						write_short(1<<1) // fade type OUT  
						write_byte(100) // fade red 
						write_byte(0) // fade green 
						write_byte(0) // fade blue  
						write_byte(255) // fade alpha  
						message_end()
					}
				}
			}
			
		}
		
	}
	else   {
		set_user_rendering(kIndex,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,255)		
	}	
	return PLUGIN_CONTINUE
}

/**********************************  STATS FUNCTION ********************************/
public update_stat_text(id) {
	
	//WarCraft 3 XP Compatibility
	if ( get_cvar_num("sv_warcraft3") || !get_cvar_num("atac_status"))  
		return PLUGIN_CONTINUE
		
	if ( is_user_bot(id) || id==0 )
		return PLUGIN_CONTINUE
	
	if ( atac_status_off[id] )
		return PLUGIN_CONTINUE
			
	new status[64]
	new atac_ta_equal_v = get_cvar_num("atac_ta_equal_v")
	new atac_tk_before_ban = get_cvar_num("atac_tk_before_ban")
	format(status,63,"[ATAC] TeamKills: %i/%i TeamAttacks: %i/%i",KickMe[id],atac_tk_before_ban,TA[id],atac_ta_equal_v)
	message_begin( MSG_ONE, gmsgStatusText, {0,0,0}, id)
	write_byte(0)
	write_string(status)
	message_end()
	
	return PLUGIN_CONTINUE
}

/***************************** CONNECTION FUNCTIONS ******************************/

public client_connect(id)
{
	if ( get_cvar_num("atac_savetks") )   {
		if ( is_user_bot(id) )
			return PLUGIN_CONTINUE
		
		new storedauthid[32]
		new storedtk[3]
		new authid[32]
		get_user_authid(id, authid ,31)
		authids[id] = authid
			
		for(new x = 0 ;x <= savedtkcount; ++x)	{
			parse(savedtks[x], storedauthid, 31, storedtk, 2 )
			if( equal(storedauthid,authid) )   {
				KickMe[id] = str_to_num(storedtk)
			}
		}
	}
	//Check client setinfo "atac_status_off" "value"
	new satac_status_off[3]
	get_user_info(id,"atac_status_off",satac_status_off,2)
	atac_status_off[id] = str_to_num(satac_status_off)
		
	return PLUGIN_CONTINUE
}
	
public client_disconnect(id)   {
	
	if ( !is_user_bot(id) && get_cvar_num("atac_savetks") )   {
		new string[35] 
		new storedauthid[32]
		new storedtk[3]
		new authid[32]
		new bool:found 
		get_user_authid(id, authid ,31)
				
		//Check for auth id already stored
		for(new x = 0 ;x <= savedtkcount; ++x)   {
			parse(savedtks[x], storedauthid, 31, storedtk, 2 )
			if( equal(storedauthid,authid) )   {
				if( KickMe[id] >= get_cvar_num("atac_tk_before_ban") )   {
					//In Case of ban, unban and reconnect on same map
					format(string ,34 ,"%s 0", authids[id])
					savedtks[x] = string
				} 
				else   {
					format(string ,34 ,"%s %i", authids[id], KickMe[id])
					savedtks[x] = string
					found = true
				}
			}
			storedauthid[0] = 0
			storedtk[0] = 0
		}
		//if not stored, store
		if( !found || savedtkcount < 300)   {
			format(string ,34 ,"%s %i", authids[id], KickMe[id])
			savedtks[savedtkcount] = string
			savedtkcount++			
		}
	}
	
	for(new i = 1 ;i <= 33; ++i)
	{
		//If disconnecting player has been killed by anyone erase history of it.
		TK[i][id] = 0
		TKHistory[i][id] = 0
		//If disconnecting player has killed anyone erase history of it. 
		TK[id][i] = 0
		TKHistory[id][i] = 0
	}
	
	StoredName[id][0] = 0
	PlayerFlags[id] = 0
	KickMe[id] = 0
	authids[id][0] = 0
	atac_status_off[id] = 0
	return PLUGIN_CONTINUE
}

/****************************** CLIENT/ADMIN FUNCTIONS *****************************/

public say_atacstatus(id,level,cid)
{
	client_print(id,3,"* [ATAC] TeamKills: %i/%i TeamAttacks: %i/%i",KickMe[id],get_cvar_num("atac_tk_before_ban"),TA[id],get_cvar_num("atac_ta_equal_v"))	
	return PLUGIN_HANDLED
}

public say_livestatus(id,level,cid)
{
	if ( atac_status_off[id] ) {
		atac_status_off[id] = 0
		update_stat_text(id)
		client_print(id,3,"* [ATAC] Live Status is now enabled")
	}
	else  {
		atac_status_off[id] = 1
		//reset atac_status	
		message_begin( MSG_ONE, gmsgStatusText, {0,0,0}, id)
		write_byte(0)
		write_string("")
		message_end()
		client_print(id,3,"* [ATAC] Live Status is now disabled (always off, use: setinfo atac_status_off ^"1^")")
	}	
	return PLUGIN_HANDLED	
}	

public say_whotkedme(id,level,cid)
{	
	//Look at all killers see if Victims Macth
	new maxplayers = get_maxplayers()
	new kName[32], message[512], entry[64]
	
	message[0] = 0
	add(message,511,"PLAYER WHO TKED ME    -    NUMBER OF TIMES^n^n",0)
		
	for(new k = 1; k <= maxplayers; ++k )
	{
		if(TKHistory[k][id] > 0 ) 
		{
			get_user_name(k,kName,31)
			format(entry ,63 ,"%s - %i^n",kName,TKHistory[k][id] )	
			add(message,511,entry,0)
			
		}		
	}	
	show_motd(id,message,"[ATAC] Who TKed Me ")
	return PLUGIN_HANDLED
}

public addmetk(id,level,cid)
{
	if (!cmd_access(id,level,cid,1)) 
		return PLUGIN_HANDLED 
	
	TK[id][id]++
	TKHistory[id][id]++
	
	if (KickMe[id] >= get_cvar_num("atac_tk_before_ban") - 1)
		draw_menu_final(id,id)							
	else
		draw_menu_page1(id,id)	
		
	client_print(id,3,"Your Flags: %i",PlayerFlags[id])
	return PLUGIN_HANDLED
}

/*************************** PRECACHE & INIT FUNCTIONS ******************************/

public plugin_precache()   {
	m_fireball = precache_model("sprites/zerogxplode.spr")
	mflash = precache_model("sprites/muzzleflash.spr") 
	m_blueflare2 = precache_model( "sprites/blueflare2.spr")
	light = precache_model("sprites/lgtning.spr")
	smoke = precache_model("sprites/steam1.spr")
	white = precache_model("sprites/white.spr")
	fire = precache_model("sprites/fexplo.spr")
	precache_sound("ambience/thunder_clap.wav")
	precache_sound("misc/chicken0.wav")
	precache_sound("ambience/flameburst1.wav")
	precache_sound("scientist/scream21.wav")
	precache_sound("scientist/scream07.wav")
	precache_sound("weapons/rocketfire1.wav")
	precache_sound("weapons/rocket1.wav")	
	
	return PLUGIN_CONTINUE
}

public plugin_init()   {
	
	register_plugin("amx_atac","2.5.0","f117bomb")
	register_cvar("atac_version", "2.5.0",FCVAR_SERVER) /* For gamespy/hlsw and such */
	server_cmd("localinfo atac_version 2.5.0") /* For Statsme/Amx Welcome */
	
	register_clcmd("amx_addmetk","addmetk",ADMIN_LEVEL_A,"- Lets you punish yourself")
	register_clcmd("say /livestatus","say_livestatus",0,"- Toggles ATAC Live Status (lower,right corner)")
	register_clcmd("say /atacstatus","say_atacstatus",0,"- Shows your TK/TA Violation Count")
	register_clcmd("say /whotkedme","say_whotkedme",0,"- Shows who has tked you")
	
	register_menucmd(register_menuid("[ATAC] Menu 1/2"),1023,"action_menu_page1")
	register_menucmd(register_menuid("[ATAC] Menu 2/2"),1023,"action_menu_page2")
	register_menucmd(register_menuid("[ATAC] Menu Final"),3,"action_menu_final")	
	
	gmsgStatusText = get_user_msgid("StatusText")
	gmsgDamage = get_user_msgid("Damage")
	gmsgDeathMsg = get_user_msgid("DeathMsg")
	gmsgHealth = get_user_msgid("Health")  
	gmsgBattery = get_user_msgid("Battery")  
	gmsgShake = get_user_msgid("ScreenShake") 
	gmsgFade = get_user_msgid("ScreenFade") 
	register_event("ScreenFade", "screen_fade", "b")
	register_event("ResetHUD", "update_stat_text", "b")
	register_event("DeathMsg","event_Death","a")
	register_event("Damage", "event_Damage", "b", "2!0", "3=0", "4!0")
	register_event("RoundTime", "event_RoundTime", "bc")
	
	register_cvar("atac_menu","1")
	register_cvar("atac_option_slap","1")
	register_cvar("atac_slap_freq","0.2")
	register_cvar("atac_tk_slaps","20")
	register_cvar("atac_slap_power","4")
	register_cvar("atac_option_slapto1","1")
	register_cvar("atac_option_rocket","1")
	register_cvar("atac_option_slay_nr","1")
	register_cvar("atac_option_jail","1")
	register_cvar("atac_jailtime","40.0")
	register_cvar("atac_option_chicken","1")
	register_cvar("atac_option_bury","1")
	register_cvar("atac_option_glow","1")
	register_cvar("atac_option_bomb","1")
	register_cvar("atac_explosion_ap","1")
	register_cvar("atac_explosion_range","1000")
	register_cvar("atac_option_blind","1")
	register_cvar("atac_option_drop","1")	
	register_cvar("atac_option_fire","1")
	register_cvar("atac_ignite_others","1")	
	register_cvar("atac_bantime","120")
	register_cvar("atac_banvia","1")
	register_cvar("atac_tk_before_ban","3")
	register_cvar("atac_handlenames","1")
	register_cvar("atac_tacontrol","1")
	register_cvar("atac_tanotallowedfor","5")
	register_cvar("atac_slayonmaxtas","1")
	register_cvar("atac_ta_equal_v","4")		
	register_cvar("atac_ta_mirrordmg","1")
	register_cvar("atac_ta_restore","1")
	register_cvar("atac_tkcontrol","1")
	register_cvar("atac_admins_immune","1")
	register_cvar("atac_savetks","1")
	register_cvar("atac_status","1")
	
	server_cmd("exec addons/amx/plugins/atac/atac.cfg")
	server_cmd("mp_tkpunish 0")
	server_cmd("mp_autokick 0")
		
	map_cors_pre = map_cors_present(map_cors_origin) /* check if that map has coordinates */
	
	return PLUGIN_CONTINUE
}

/********************************** SPECIAL FX ************************************/

draw_fire( vec[3] )   {

	//TE_SPRITE - additive sprite, plays 1 cycle
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte( 17 ) 
	write_coord(vec[0])  // coord, coord, coord (position) 
	write_coord(vec[1])  
	write_coord(vec[2]) 
	write_short( mflash ) // short (sprite index) 
	write_byte( 20 ) // byte (scale in 0.1's)  
	write_byte( 200 ) // byte (brightness)
	message_end()
	
	//Smoke
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec)
	write_byte( 5 )
	write_coord(vec[0])// coord coord coord (position) 
	write_coord(vec[1])
	write_coord(vec[2])
	write_short( smoke )// short (sprite index)
	write_byte( 20 ) // byte (scale in 0.1's)
	write_byte( 15 ) // byte (framerate)
	message_end()
	
	return PLUGIN_CONTINUE
}

draw_trail(vec[3])   {
	//TE_SPRITETRAIL - line of moving glow sprites with gravity, fadeout, and collisions
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( 15 )
	write_coord( vec[0]) // coord, coord, coord (start)
	write_coord( vec[1])
	write_coord( vec[2])
	write_coord( vec[0]) // coord, coord, coord (end) 
	write_coord( vec[1])
	write_coord( vec[2] - 30)
	write_short( m_blueflare2 ) // short (sprite index)
	write_byte( 5 ) // byte (count)
	write_byte( 1 ) // byte (life in 0.1's)
	write_byte( 1 )  // byte (scale in 0.1's)
	write_byte( 10 ) // byte (velocity along vector in 10's)
	write_byte( 5 )  // byte (randomness of velocity in 10's)
	message_end() 
	
	//TE_SPRITE - additive sprite, plays 1 cycle
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte( 17 ) 
	write_coord(vec[0])  // coord, coord, coord (position) 
	write_coord(vec[1])  
	write_coord(vec[2] - 30) 
	write_short( mflash ) // short (sprite index) 
	write_byte( 15 ) // byte (scale in 0.1's)  
	write_byte( 255 ) // byte (brightness)
	message_end() 
		
	return PLUGIN_CONTINUE
}

explode(vec1[3])   {
	
	// blast circles
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 21 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 16)
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] + 1936)
	write_short( white )
	write_byte( 0 ) // startframe
	write_byte( 0 ) // framerate
	write_byte( 2 ) // life
	write_byte( 16 ) // width
	write_byte( 0 ) // noise
	write_byte( 188 ) // r
	write_byte( 220 ) // g
	write_byte( 255 ) // b
	write_byte( 255 ) //brightness
	write_byte( 0 ) // speed
	message_end()
	
	//Explosion2
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 12 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_byte( 188 ) // byte (scale in 0.1's)
	write_byte( 10 ) // byte (framerate)
	message_end()
	
	//Smoke
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 5 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short( smoke )
	write_byte( 2 ) 
	write_byte( 10 ) 
	message_end()
	
	return PLUGIN_CONTINUE
}

fireball(vec1[3])   {
	
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 17 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2] +256)
	write_short( fire )
	write_byte( 120 ) // scale * 10
	write_byte( 255 ) // brightness
	message_end()
		
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( 14 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_byte(100)
	write_byte(20)
	write_byte(5)
	message_end()
	
	// random explosions
	message_begin( MSG_PVS, SVC_TEMPENTITY, vec1 )
	write_byte( 3 )
	write_coord( vec1[0] )
	write_coord( vec1[1] )
	write_coord( vec1[2] )
	write_short( m_fireball )
	write_byte( 30  ) 
	write_byte( 12  ) 
	write_byte( 0 )
	message_end()

	// lots of smoke
	message_begin( MSG_PVS, SVC_TEMPENTITY, vec1 )
	write_byte( 5 )
	write_coord( vec1[0] )
	write_coord( vec1[1] )
	write_coord( vec1[2] )
	write_short( smoke )
	write_byte( 60 ) 
	write_byte( 10  ) 
	message_end()
	
	return PLUGIN_CONTINUE
}

lightning(vec1[3])
{
	//Lightning
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( 0 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_coord(vec1[0] + 150)
	write_coord(vec1[1] + 150)
	write_coord(vec1[2] + 400)
	write_short( light )
	write_byte( 1 ) // framestart
	write_byte( 5 ) // framerate
	write_byte( 2 ) // life
	write_byte( 20 ) // width
	write_byte( 30 ) // noise
	write_byte( 200 ) // r, g, b
	write_byte( 200 ) // r, g, b
	write_byte( 200 ) // r, g, b 
	write_byte( 200 ) // brightness
	write_byte( 200 ) // speed
	message_end()

	//Sparks
	message_begin( MSG_PVS, SVC_TEMPENTITY,vec1)
	write_byte( 9 )
	write_coord( vec1[0] )
	write_coord( vec1[1] )
	write_coord( vec1[2] )
	message_end()
	
	//Smoke	
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1)
	write_byte( 5 )
	write_coord(vec1[0])
	write_coord(vec1[1])
	write_coord(vec1[2])
	write_short( smoke )
	write_byte( 10 ) 
	write_byte( 10 ) 
	message_end()
	
	return PLUGIN_CONTINUE
	
}